/*
	VM2.r - commando resource file for the SGML Validator VM2.
	
	VM2 [-s] [-c] [-d] [-e] [-f] [-g] [-mpath] [-pn] [-r] entity-id
	
		-s			Show details of SGML parsing (default: error messages only, no details).
		-c			Data or PI chars to print if -S specified: 0 or more (default: 10).
		-d			Report duplicate entity declarations (default: not reported).
		-e			Suppress entity stack trace in error msg (default: entity trace on).
		-f			Files located in current directory only (default: files anywhere on path).
		-g			Suppress GI stack trace in error messages (default: GI trace on).
		-mpath		Pathname of error message file (default: SGML.MSG).
		-pn			n = Number of passes desired: 1 or more (default: 1 pass).
		-r			Give warning for defaulted entity references (default: no warning).
		entity-id	The "entity-id" is a Macintosh file specification that identifies the
					initial SGML document entity. 
 */

#include	"Cmdo.r"

resource 'cmdo' (128) {
	{	/* array dialogs: 2 elements */
		/* [1] */
		296,
		"Parse the named SGML entity.",
		{	/* array itemArray: 13 elements */
			/* [1] */
			NotDependent {

			},
			Files {
				InputFile,
				RequiredFile {
					{15, 57, 36, 219},
					"SGML Entity-id",
					"",
					"Specify the SGML entity-id of the initia"
					"l entity to be parsed."
				},
				Additional {
					"",
					"",
					"",
					"",
					{	/* array TypesArray: 1 elements */
						/* [1] */
						text
					}
				}
			},
			/* [2] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			Files {
				InputFile,
				RequiredFile {
					{15, 261, 36, 423},
					"Error Messages",
					"-m",
					"Name of Error Message File (default: SGM"
					"L.MSG)."
				},
				Additional {
					"",
					"",
					"",
					"",
					{	/* array TypesArray: 1 elements */
						/* [1] */
						text
					}
				}
			},
			/* [3] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			NestedDialog {
				2,
				{43, 167, 64, 308},
				"I/O Redirection...",
				"Click this button to open a dialog with "
				"redirection controls.  You must specify "
				"at least  \"SGML Entity-id\" to enable thi"
				"s button."
			},
			/* [4] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					-12
				}
			},
			CheckOption {
				NotSet,
				{78, 14, 95, 184},
				"Show parsing details.",
				"-s",
				"Show details of SGML parsing (default: e"
				"rror messages only)."
			},
			/* [5] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{93, 14, 108, 282},
				"Report duplicate entity declarations.",
				"-d",
				"Report duplicate entity declarations (de"
				"fault: not reported)."
			},
			/* [6] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{108, 14, 123, 231},
				"Suppress entity stack trace.",
				"-e",
				"Suppress entity stack trace in error mes"
				"sage (default: entity trace on)."
			},
			/* [7] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{123, 14, 140, 305},
				"Suppress Generic Identifier stack trace.",
				"-g",
				"Suppress Generic Identifier stack trace "
				"in error messages (default: Generic Iden"
				"tifier trace on)."
			},
			/* [8] */
			NotDependent {

			},
			CheckOption {
				NotSet,
				{138, 14, 153, 283},
				"Warn of defaulted entity references.",
				"-r",
				"Give warning for defaulted entity refere"
				"nces (default: no warning)."
			},
			/* [9] */
			NotDependent {

			},
			RegularEntry {
				"Characters",
				{81, 319, 97, 407},
				{80, 425, 96, 460},
				"10",
				ignoreCase,
				"-c",
				"Data or PI characters to print if detail"
				"ed parse is specified."
			},
			/* [10] */
			NotDependent {

			},
			RegularEntry {
				"Passes",
				{111, 349, 127, 409},
				{109, 426, 125, 461},
				"1",
				ignoreCase,
				"-p",
				"Number of passes desired: 1 or more (def"
				"ault: 1)."
			},
			/* [12] */
			NotDependent {

			},
			TextBox {
				black,
				{71, 10, 186, 470},
				"Options"
			},
			/* [13] */
			Or {
				{	/* array OrArray: 1 elements */
					/* [1] */
					1
				}
			},
			DoItButton {

			}
		},
		/* [2] */
		192,
		"I/O redirection.",
		{	/* array itemArray: 2 elements */
			/* [1] */
			NotDependent {

			},
			Redirection {
				StandardOutput,
				{26, 183}
			},
			/* [2] */
			NotDependent {

			},
			Redirection {
				DiagnosticOutput,
				{26, 338}
			}
		}
	}
};
